// (c) 2020 Takamitsu Endo
//
// This file is part of SevenDelay.
//
// SevenDelay is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// SevenDelay is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SevenDelay.  If not, see <https://www.gnu.org/licenses/>.

#pragma once

#include "../../common/gui/plugeditor.hpp"
#include "gui/waveview.hpp"
#include "parameter.hpp"

namespace Steinberg {
namespace Vst {

using namespace VSTGUI;

class Editor : public PlugEditor {
public:
  Editor(void *controller);
  ~Editor();

  void valueChanged(CControl *pControl) override;
  void updateUI(Vst::ParamID id, ParamValue normalized) override;
  void refreshWaveView(Vst::ParamID id);
  void refreshTimeTextView(Vst::ParamID id);

  DELEGATE_REFCOUNT(VSTGUIEditor);

protected:
  WaveView *waveView = nullptr;
  TextView *timeTextView = nullptr;

  bool prepareUI() override;
  void addWaveView(const CRect &size);
  ParamValue getPlainValue(ParamID tag);
};

} // namespace Vst
} // namespace Steinberg
